/********************************************************************************************************\

	File Name:	Mul_CoopAce.h
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#if !defined( Mul_CoopAce_h )
#define Mul_CoopAce_h

#include "ScriptInterface.h"
#include "ShipList.h"
#include "coopcustomizer common files\coopdata.h"


typedef std::vector<std::string> PlayerShipClassNameList;


struct hulltype_linklist {
	 int BPVtoMatch;
	 int oddsInPercent;
	 ShipList *shiplistbyHull;
	 hulltype_linklist *Next;
};

// global variables
extern PlayerShipClassNameList pscnl;
extern ShipList global_sl;
extern ShipList selected_human_sl;
extern ShipList selected_enemy_sl;
extern ShipList carry_over_sl;  
extern ShipList carry_over_fighter_sl;  
extern int32 latestShip;
extern int bpv_to_assign; 
extern int extras_bpv_to_assign;
extern int completed_startup;
extern hulltype_linklist *hulltype_sl_list;


// extra ship data tracking.
/*
extern int shipcount;
extern int32 all_ships_IDs[50];
extern int32 all_ships_teams[50];
extern int32 all_ships_state[50];
extern int32 all_ships_transporters[50];
extern int32 all_ships_marines[50];
extern int32 all_ships_targets[50];
*/

// for the delay tracking.
extern int AlertStateChanged;
extern int32 ZeroTimeCount;
extern int DelayComplete;

// useful:
extern eTeamID own_player_team;


class tMul_CoopAce : public tScript
{
public:

	tMul_CoopAce();

	virtual void	mStartMission();
	virtual int32	mInitializeStart( tDynaverseScriptInfo& info );
	virtual void	mCreateExternalShips( int32 Mode );
	virtual int32	mInitializeFinished();
	virtual void	mNewInternalShip( tShipInfo* Ship );
	virtual void	mScriptSpecs( tMissionSpec* Specs );
	virtual void	mNewTeam( const tTeamScriptDescription& teamScriptDescription );
	virtual void	mASCIIOverrides( tMapOverrides* Map );
};


// undefine if you need DEBUG file.
// #define DEBUGMODE 1
// #define PROBE_TWEAK 1
#ifdef PROBE_TWEAK
extern int32 ProbeTargetsShipID[108];
extern int32 ProbeSendersShipID[108];
#endif

#endif

