/********************************************************************************************************\

	File Name:	CommonDefs.h
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#if !defined( CommonDefs_h )
#define CommonDefs_h

#include "EnemyTeam.h"
#include "Mul_CoopAce.h"

extern int DamCon_to_SpareParts( int DamCon );
extern void RemoveFightersFromShip( tShipInfo* ship );
extern void Populate_selected_enemy_sl ( void );
extern void Populate_carry_over_fighter_sl ( void );

extern void debug_fprintf ( FILE* fp, const char* format, ...);

extern enum eAICaptureState
{
	eNothing = 0,
	eGotTransporters,
	eGotOwnMarines,
};

enum
{
	kEBegin=-999,
	kEEnd=0, // Z-DDV (YFA=0) is in early
	kMBegin=1, // fighter Z-Mastiff.II (YFA=1) is in mid
	kMEnd=7, // F-NCL (YFA=7) is in mid for start
	kLBegin=8, // F-NCD (YFA=8) is in late for start.
	kX1Begin=27, // To help find X1 ships.
	kLEnd=36,  // NOTE!!! It was discovered that OP's advanced era was starting at 2290 BEFORE 2.5.5.0. Now it's back to 2300.
	kX1End=36,
	kABegin=37, // (F-XFF YFA=37)
	kAEnd=999,
};

#endif

