// DigitsEdit.cpp : implementation file
//

#include "stdafx.h"
#include "coopcustomizer.h"
#include "DigitsEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDigitsEdit

CDigitsEdit::CDigitsEdit()
{
}

CDigitsEdit::~CDigitsEdit()
{
}


BEGIN_MESSAGE_MAP(CDigitsEdit, CEdit)
	//{{AFX_MSG_MAP(CDigitsEdit)
	ON_WM_CHAR()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDigitsEdit message handlers

void CDigitsEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if( !(isdigit( nChar ) || (nChar == VK_BACK) || (nChar == VK_TAB)) )
		return;

	CEdit::OnChar(nChar, nRepCnt, nFlags);
}


void CDigitsEdit::OnKillFocus(CWnd* pNewWnd) 
{
	CEdit::OnKillFocus(pNewWnd);

	TCHAR arszText[ 16 ];
	GetWindowText( arszText, sizeof( arszText ) );

	int nPercentage = _ttoi( arszText );
	if( nPercentage > 100 )
		nPercentage = 100;
	
	if( nPercentage != 0 )
		_stprintf( arszText, _T( "%d" ), nPercentage );

	SetWindowText( arszText );
}
