//	<Name>	shipclasses.h
//
//	<Legal>	Copyright (c)  by Taldren, Inc. ALL RIGHTS RESERVED.
//	This document contains CONFIDENTIAL, PROPRIETARY, TRADE SECRET information
//	belonging to Taldren, Inc. and may not be reproduced, in whole
//	or in part, without prior written permission from Taldren, Inc.
//
//	<Info>
//
#pragma once

#if ! defined ( ShipClasses_h )
#define ShipClasses_h

// if adding or deleting from this list be sure to change dynaverse.txt also
// and rebuild a new strings.txt file
enum eClassTypes
{
	kNoClassType = -1,
	kClassShuttle = 0,				// smallest hull size
	kClassPseudoFighter,
	kClassFreighter,
	kClassFrigate,
	kClassDestroyer,
	kClassWarDestroyer,
	kClassLightCruiser,
	kClassHeavyCruiser,
	kClassNewHeavyCruiser,
	kClassHeavyBattlecruiser,
	kClassCarrier,
	kClassDreadnought,
	kClassBattleship,				// largest hull size

	kClassFirstShip = kClassShuttle,
	kClassLastShip = kClassBattleship,

	// START STAR BASES: AFSNOTE: If these fields are modified, it should be noted that there are several areas in the code that rely
	// on the fact that these are the only starbase ship types.  There are also assumptions about this enum made in older sections of 
	// the tactical code.
	kClassListeningPost,
	kClassBaseStation,
	kClassBattleStation,
	kClassStarBase,

	kClassFirstBase = kClassListeningPost,
	kClassLastBase = kClassStarBase,

	kClassLastVessel = kClassLastBase,

	kClassMonster,
	kClassPlanets,
	kClassSpecial,
	kMaxClasses,
};

#endif

