/********************************************************************************************************\

	File Name:	EnemyTeam.h
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#if !defined( EnemyTeam_h )
#define EnemyTeam_h

#if !defined( TeamInfo_h )
#include "TeamInfo.h"
#define TeamInfo_h
#endif

#include "Mul_CoopAce.h"
#define ERA_YEAR_BASED 1

#define monster_percentage 10
#define bb_percentage 10
#define dn_percentage 30
#define cv_percentage 20
#define bch_percentage 55
#define nca_percentage 45
#define ca_percentage 60
#define cl_percentage 65
#define wd_percentage 50
#define dd_percentage 70
#define ff_percentage 80

class tEnemyTeam : public tTeamInfo
{
public:

	virtual void mSetupState();
	virtual void mSetupCommState();
	virtual void mCreateShipsForTeam();
	virtual void mTeamSetupComplete();

/*

	HELPER NOTE:	Below is where the list of the ship custom IDs go.  An example follows.

	enum eCustomIDs
	{
		kPlayerNPC1,
		kPlayerNPC2,
	};

*/
	enum eCustomIDs
	{};

	void mCreateCoopEnemy(void);
	void tEnemyTeam::free_linklist(hulltype_linklist *list, hulltype_linklist *first);
};

enum
{
	// kShuttleItem,
	ktBombItem = 0,
	kMarineItem,
	kSparePartItem,
	kLastItem,
};

enum
{
	kShuttleItemValue = 1,
	ktBombItemValue = 4,
	kMarineItemValue = 2,
	kSparePartItemValue = 4,
};

#endif

